// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Parser.pas' rev: 3.00

#ifndef ParserHPP
#define ParserHPP
#include <Plotdefs.hpp>
#include <Misc.hpp>
#include <StdCtrls.hpp>
#include <Grids.hpp>
#include <Graphics.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Controls.hpp>
#include <ComCtrls.hpp>
#include <Buttons.hpp>
#include <Windows.hpp>
#include <SysUtils.hpp>
#include <Classes.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Parser
{
//-- type declarations -------------------------------------------------------
enum TDelimiter { dlNone, dlTab, dlComma, dlSpace, dlColon, dlSemiColon, dlLineFeed, dlOwn };

enum TColumnType { ctIgnore, ctX, ctY };

struct TSeriesInfo
{
	int Index;
	int XCol;
	int XTextCol;
	int YCol;
	int XSeriesIndex;
	float XValue;
	float YValue;
} ;

typedef TSeriesInfo TSeriesInfoArray[1024];

typedef TSeriesInfoArray *pSeriesInfoArray;

typedef System::AnsiString Parser__2[8];

class DELPHICLASS TParserForm;
class PASCALIMPLEMENTATION TParserForm : public Forms::TForm 
{
	typedef Forms::TForm inherited;
	
__published:
	Stdctrls::TListBox* DataListBox;
	Stdctrls::TLabel* DelimiterLabel;
	Stdctrls::TComboBox* DelimiterComboBox;
	Stdctrls::TEdit* LineEdit;
	Stdctrls::TGroupBox* SetGroupBox;
	Stdctrls::TButton* SeriesNamesButton;
	Stdctrls::TButton* FirstLineOfDataButton;
	Buttons::TBitBtn* HelpBitBtn;
	Buttons::TBitBtn* BitBtn2;
	Buttons::TBitBtn* OKBitBtn;
	Grids::TStringGrid* InfoGrid;
	Stdctrls::TComboBox* PickXDataComboBox;
	Stdctrls::TButton* ZDataLineButton;
	Stdctrls::TLabel* NoSeriesLabel;
	Buttons::TBitBtn* ExpandBitBtn;
	Extctrls::TTimer* Timer1;
	Stdctrls::TLabel* InstructionsLabel;
	void __fastcall FormCreate(System::TObject* Sender);
	void __fastcall DataListBoxClick(System::TObject* Sender);
	void __fastcall FirstLineOfDataButtonClick(System::TObject* Sender);
	void __fastcall SeriesNamesButtonClick(System::TObject* Sender);
	void __fastcall InfoGridClick(System::TObject* Sender);
	void __fastcall PickXDataComboBoxClick(System::TObject* Sender);
	void __fastcall HelpBitBtnClick(System::TObject* Sender);
	void __fastcall ZDataLineButtonClick(System::TObject* Sender);
	void __fastcall FormResize(System::TObject* Sender);
	void __fastcall ExpandBitBtnClick(System::TObject* Sender);
	void __fastcall Timer1Timer(System::TObject* Sender);
	
private:
	int OriginalHeight;
	int InstructionIndex;
	void __fastcall CheckDelimiter(void);
	void __fastcall CalculateNoSeries(void);
	
public:
	System::AnsiString Delimiters[8];
	TDelimiter TheDelimiter;
	int TheFirstDataLine;
	int TheSeriesNamesLine;
	int TheSeriesUnitsLine;
	int TheZDataLine;
	int NumberOfSeries;
	int TheCol;
	int TheRow;
	bool XDataPresent;
	void __fastcall DoHintsFromResource(void);
public:
	/* TCustomForm.Create */ __fastcall virtual TParserForm(Classes::TComponent* AOwner) : Forms::TForm(
		AOwner) { }
	/* TCustomForm.CreateNew */ __fastcall TParserForm(Classes::TComponent* AOwner, int Dummy) : Forms::
		TForm(AOwner, Dummy) { }
	/* TCustomForm.Destroy */ __fastcall virtual ~TParserForm(void) { }
	
public:
	/* TWinControl.CreateParented */ __fastcall TParserForm(HWND ParentWindow) : Forms::TForm(ParentWindow
		) { }
	
};

//-- var, const, procedure ---------------------------------------------------
#define COLUMN_NOS (Byte)(0)
#define SERIES_NAMES (Byte)(1)
#define FIRST_LINE_OF_DATA (Byte)(2)
#define X_OR_Y_OR_Z (Byte)(3)
#define DEPENDS_ON_X (Byte)(4)
#define Z_DATA_LINE (Byte)(5)
extern PACKAGE System::AnsiString DelimiterNames[8];
extern PACKAGE TParserForm* ParserForm;

}	/* namespace Parser */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Parser;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// Parser
